
C     ===============================
      subroutine smb_polwgt(x,xi,n,w)
C     ===============================

C--   Setup weights for 1, 2, 3-point interpolation

      implicit double precision (a-h,o-z)

      dimension xi(*), w(*)

      if(n.eq.3)     then
        w(1) = (x-xi(1))/(xi(2)-xi(1))
        w(2) = 1.D0 - w(1)
        w(3) = (x-xi(2))/(xi(3)-xi(2))
        w(4) = 1.D0 - w(3)
        w(5) = (x-xi(1))/(xi(3)-xi(1))
        w(6) = 1.D0 - w(5)
      elseif(n.eq.2) then
        w(1) = (x-xi(1))/(xi(2)-xi(1))
        w(2) = 1.D0 - w(1)
      elseif(n.eq.1) then
        w(1) = 1.D0
      else
        stop 'SMB_POLWGT: invalid interpolation order'
      endif

      return
      end

C     ============================================
      double precision function dmb_polin1(w,fi,n)
C     ============================================

C--   1-dim interpolation of order 1,2,3

      implicit double precision (a-h,o-z)

      dimension w(*), fi(*)

      if(n.eq.3)     then
        g          = w(1)*fi(1) + w(2)*fi(2)
        h          = w(3)*fi(2) + w(4)*fi(3)
        dmb_polin1 = w(5)*g + w(6)*h
      elseif(n.eq.2) then
        dmb_polin1 = w(1)*fi(1) + w(2)*fi(2)
      elseif(n.eq.1) then
        dmb_polin1 = fi(1)
      else
        stop 'SMB_POLIN1: invalid interpolation order'
      endif

      return
      end

C     =======================================================
      double precision function dmb_polin2(wx,nx,wy,ny,fij,m)
C     =======================================================

C--   2-dim interpolation on an nx * ny mesh

      implicit double precision (a-h,o-z)

      dimension wx(*), wy(*), fij(m,*), fi(3)

      if(nx.lt.1 .or. nx.gt.3)
     + stop 'SMB_POLIN2: invalid interpolation order in x'
      if(ny.lt.1 .or. ny.gt.3)
     + stop 'SMB_POLIN2: invalid interpolation order in y'

       do j = 1,ny
          fi(j) = dmb_polin1(wx,fij(1,j),nx)
       enddo
       dmb_polin2 = dmb_polin1(wy,fi,ny)

       return
       end


