
C--  This is the file srcEvParams.f with evolutiion parameter routines
C--
C--   integer function iqcParId(ww,kset,i)
C--   subroutine sqcPar6toA(array)
C--   subroutine sqcAtoPar6(array)
C--   subroutine sqcBufPar6(iadd,ierr)
C--   subroutine sqcSetPar6(ww,kset)
C--   subroutine sqcGetPar6(ww,kset)
C--   subroutine sqcSetPar(ww,kset,i,val)
C--   subroutine sqcGetPar(ww,kset,i,val)
C--   subroutine sqcCpyPar(w1,kset1,w2,kset2)
C--   subroutine sqcClrPar(ww,kset)
C--   logical function lqcParsEqPar6(ww,kset)
C--   logical function lqcParEqVal(ww,kset,i,val)

C==   ==================================================================
C==   Global address function ==========================================
C==   ==================================================================

C     ====================================
      integer function iqcParId(ww,kset,i)
C     ====================================

C--   Returns address of parameter i in table set kset
C--
C--   ww   (in) : workspace
C--   kset (in) : table set identifier
C--   i    (in) : parameter number [1,mpar0]

      iqcParId  = iqcFirstWordOfParams(ww,kset)-1+i

      return
      end

C==   ==================================================================
C==   Parameters to and from array
C==   ==================================================================

C     ============================
      subroutine sqcPar6toA(array)
C     ============================

C--   Copy the parameters of common block qpars6 into array
C--   The indexing is defined in qpars6.inc

      implicit double precision (a-h,o-z)

      include 'qcdnum.inc'
      include 'qgrid2.inc'
      include 'qpars6.inc'

      dimension array(*)

C--   Nothing to do if versions are the same
      iver = int(array(idipver6))
      if(iver.eq.ipver6) return

      diord6 = dble(iord6)
      if(Lmfns6) then
        dnfix6 = -dble(nfix6)
      else
        dnfix6 =  dble(nfix6)
      endif
      dipver6  = dble(ipver6)
      dievtyp6 = dble(ievtyp6)

      array(idiord6 )  = diord6
      array(idalfq06)  = alfq06
      array(idq0alf6)  = q0alf6
      array(idnfix6 )  = dnfix6
      array(idqthrc6)  = qthrs6(4)
      array(idqthrb6)  = qthrs6(5)
      array(idqthrt6)  = qthrs6(6)
      array(idtthrc6)  = tthrs6(4)
      array(idtthrb6)  = tthrs6(5)
      array(idtthrt6)  = tthrs6(6)
      array(idrthrc6)  = rthrs6(4)
      array(idrthrb6)  = rthrs6(5)
      array(idrthrt6)  = rthrs6(6)
      array(idaar6  )  = aar6
      array(idbbr6  )  = bbr6
      array(idymaxc2)  = ymaxc2
      array(idtminc2)  = tminc2
      array(idtmaxc2)  = tmaxc2
      array(idaslim6)  = aslim6
      array(idipver6)  = dipver6
      array(idievtyp6) = dievtyp6

      return
      end

C     ============================
      subroutine sqcAtoPar6(array)
C     ============================

C--   Copy the parameters of array into common block qpars6
C--   Also update the internal lookup tables if necessary
C--   The indexing is defined in qpars6.inc

      implicit double precision (a-h,o-z)

      include 'qcdnum.inc'
      include 'qgrid2.inc'
      include 'qpars6.inc'
      include 'qmaps8.inc'

      dimension array(*)

C--   Nothing to do if versions are the same
      iver = int(array(idipver6))
      if(iver.eq.ipver6) return

      val = array(idiord6)
      ival = int(val)
      if(ival.ne.iord6) Lastab8 = .false.
      iord6 = ival

      val = array(idalfq06)
      if(val.ne.alfq06) Lastab8 = .false.
      alfq06 = val

      val = array(idq0alf6)
      if(val.ne.q0alf6) Lastab8 = .false.
      q0alf6 = val

      val = array(idnfix6)
      ival = int(val)
      if(ival.ge.0) then
        Lmfns6 = .false.
      else
        Lmfns6 = .true.
        ival   = -ival
      endif
      if(ival.ne.nfix6) then
        Levcut8 = .false.
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      nfix6 = ival

      val = array(idqthrc6)
      if(val.ne.qthrs6(4)) then
        Levcut8 = .false.
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      qthrs6(4) = val

      val = array(idqthrb6)
      if(val.ne.qthrs6(5)) then
        Levcut8 = .false.
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      qthrs6(5) = val

      val = array(idqthrt6)
      if(val.ne.qthrs6(6)) then
        Levcut8 = .false.
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      qthrs6(6) = val

      val = array(idtthrc6)
      if(val.ne.tthrs6(4)) then
        Levcut8 = .false.
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      tthrs6(4) = val

      val = array(idtthrb6)
      if(val.ne.tthrs6(5)) then
        Levcut8 = .false.
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      tthrs6(5) = val

      val = array(idtthrt6)
      if(val.ne.tthrs6(6)) then
        Levcut8 = .false.
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      tthrs6(6) = val

      val = array(idrthrc6)
      if(val.ne.rthrs6(4)) then
        Levcut8 = .false.
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      rthrs6(4) = val

      val = array(idrthrb6)
      if(val.ne.rthrs6(5)) then
        Levcut8 = .false.
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      rthrs6(5) = val

      val = array(idrthrt6)
      if(val.ne.rthrs6(6)) then
        Levcut8 = .false.
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      rthrs6(6) = val

      val = array(idaar6)
      if(val.ne.aar6) Lastab8 = .false.
      aar6 = val

      val = array(idbbr6)
      if(val.ne.bbr6) Lastab8 = .false.
      bbr6 = val

      val = array(idymaxc2)
      if(val.ne.ymaxc2) Levcut8 = .false.
      ymaxc2 = val

      val = array(idtminc2)
      if(val.ne.tminc2) Levcut8 = .false.
      tminc2 = val

      val = array(idtmaxc2)
      if(val.ne.tmaxc2) Levcut8 = .false.
      tmaxc2 = val

      val = array(idaslim6)
      if(val.ne.aslim6) Lastab8 = .false.
      aslim6 = val

      val = array(idipver6)
      ipver6 = int(val)

      val = array(idievtyp6)
      ievtyp6 = int(val)

C--   Update of internal lookup tables
      if(.not.Lnfmap8) then
        call sqcNfTab(0)
        Lnfmap8 = .true.
      endif
      if(.not.Lastab8) then
        call sqcAlfTab(iord6)
        Lastab8 = .true.
      endif
      if(.not.Levcut8) then
        call sqcEvCuts(0)
        Levcut8 = .true.
      endif

      return
      end

C==   ==================================================================
C==   Handle evolution parameters ======================================
C==   ==================================================================

C     ================================
      subroutine sqcBufPar6(iadd,ierr)
C     ================================

C--   Parameters of /qpars6/ <--> LIFO buffer
C--
C--   iadd  (in) : +1 /qpars6/ -->  parbf6
C--                -1  parbf6  --> /qpars6/
C--   ierr (out) : -1  parbf6 empty
C--                 0  OK
C--                 1  parbf6 full
C--                 2  wrong iadd --> do nothing

      implicit double precision (a-h,o-z)

      include 'qcdnum.inc'
      include 'qpars6.inc'

      save ipos
      data ipos /0/

      if(iadd.eq.+1) then
        ipos = ipos+1
        if(ipos.le.npbuf0) then
          call sqcPar6toA(parbf6(1,ipos))
          ierr   =  0
        else
          ierr = 1
        endif
      elseif(iadd.eq.-1) then
        if(ipos.ge.1) then
          call sqcAtoPar6(parbf6(1,ipos))
          ierr   =  0
          ipos   =  ipos-1
        else
          ierr   = -1
        endif
      else
        ierr = 2
      endif

      return
      end

C     ==============================
      subroutine sqcSetPar6(ww,kset)
C     ==============================

C--   Copy the parameters of kset into common block qpars6
C--   Also update the internal lookup tables if necessary
C--   The indexing is defined in qpars6.inc

      implicit double precision (a-h,o-z)

      include 'qcdnum.inc'
      include 'qgrid2.inc'
      include 'qpars6.inc'
      include 'qmaps8.inc'

      dimension ww(*)

      logical lqcIsetExists

      if(.not.lqcIsetExists(ww,kset)) then
        stop 'sqcSetPar6: kset does not exist'
      endif
      if(iqcGetNumberOfParams(ww,kset).lt.mpar0) then
        stop 'sqcSetPar6: not enough parameter space'
      endif

      call sqcGetPar(ww, kset, idiord6,  val)
      ival = int(val)
      if(ival.ne.iord6) Lastab8 = .false.
      iord6 = ival

      call sqcGetPar(ww, kset, idalfq06, val)
      if(val.ne.alfq06) Lastab8 = .false.
      alfq06 = val

      call sqcGetPar(ww, kset, idq0alf6, val)
      if(val.ne.q0alf6) Lastab8 = .false.
      q0alf6 = val

      call sqcGetPar(ww, kset, idnfix6,  val)
      ival = int(val)
      if(ival.ge.0) then
        Lmfns6 = .false.
      else
        Lmfns6 = .true.
        ival   = -ival
      endif
      if(ival.ne.nfix6) then
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      nfix6 = ival

      call sqcGetPar(ww, kset, idqthrc6, val)
      if(val.ne.qthrs6(4)) then
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      qthrs6(4) = val

      call sqcGetPar(ww, kset, idqthrb6, val)
      if(val.ne.qthrs6(5)) then
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      qthrs6(5) = val

      call sqcGetPar(ww, kset, idqthrt6, val)
      if(val.ne.qthrs6(6)) then
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      qthrs6(6) = val

      call sqcGetPar(ww, kset, idtthrc6, val)
      if(val.ne.tthrs6(4)) then
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      tthrs6(4) = val

      call sqcGetPar(ww, kset, idtthrb6, val)
      if(val.ne.tthrs6(5)) then
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      tthrs6(5) = val

      call sqcGetPar(ww, kset, idtthrt6, val)
      if(val.ne.tthrs6(6)) then
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      tthrs6(6) = val

      call sqcGetPar(ww, kset, idrthrc6, val)
      if(val.ne.rthrs6(4)) then
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      rthrs6(4) = val

      call sqcGetPar(ww, kset, idrthrb6, val)
      if(val.ne.rthrs6(5)) then
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      rthrs6(5) = val

      call sqcGetPar(ww, kset, idrthrt6, val)
      if(val.ne.rthrs6(6)) then
        Lnfmap8 = .false.
        Lastab8 = .false.
      endif
      rthrs6(6) = val

      call sqcGetPar(ww, kset, idaar6,   val)
      if(val.ne.aar6) Lastab8 = .false.
      aar6 = val

      call sqcGetPar(ww, kset, idbbr6,   val)
      if(val.ne.bbr6) Lastab8 = .false.
      bbr6 = val

      call sqcGetPar(ww, kset, idymaxc2,  val)
      if(val.ne.ymaxc2) Levcut8 = .false.
      ymaxc2 = val

      call sqcGetPar(ww, kset, idtminc2,  val)
      if(val.ne.tminc2) Levcut8 = .false.
      tminc2 = val

      call sqcGetPar(ww, kset, idtmaxc2,  val)
      if(val.ne.tmaxc2) Levcut8 = .false.
      tmaxc2 = val

      call sqcGetPar(ww, kset, idaslim6, val)
      if(val.ne.aslim6) Lastab8 = .false.
      aslim6 = val

      call sqcGetPar(ww, kset, idipver6, val)
      ipver6 = int(val)

C--   Update of internal lookup tables
      if(.not.Lnfmap8) then
        call sqcNfTab(0)
        Lnfmap8 = .true.
      endif
      if(.not.Lastab8) then
        call sqcAlfTab(iord6)
        Lastab8 = .true.
      endif
      if(.not.Levcut8) then
        call sqcEvCuts(0)
        Levcut8 = .true.
      endif

      return
      end

C     ==============================
      subroutine sqcGetPar6(ww,kset)
C     ==============================

C--   Copy the parameters of common block qpars6 into kset
C--   The indexing is defined in qpars6.inc

      implicit double precision (a-h,o-z)

      include 'qcdnum.inc'
      include 'qgrid2.inc'
      include 'qpars6.inc'

      dimension ww(*)

      logical lqcIsetExists

      if(.not.lqcIsetExists(ww,kset)) then
        stop 'sqcGetPar6: kset does not exist'
      endif
      if(iqcGetNumberOfParams(ww,kset).lt.mpar0) then
        stop 'sqcGetPar6: not enough parameter space'
      endif

      diord6 = dble(iord6)
      if(Lmfns6) then
        dnfix6 = -dble(nfix6)
      else
        dnfix6 =  dble(nfix6)
      endif
      dipver6 = dble(ipver6)

      call sqcSetPar(ww, kset, idiord6,  diord6    )
      call sqcSetPar(ww, kset, idalfq06, alfq06    )
      call sqcSetPar(ww, kset, idq0alf6, q0alf6    )
      call sqcSetPar(ww, kset, idnfix6,  dnfix6    )
      call sqcSetPar(ww, kset, idqthrc6, qthrs6(4) )
      call sqcSetPar(ww, kset, idqthrb6, qthrs6(5) )
      call sqcSetPar(ww, kset, idqthrt6, qthrs6(6) )
      call sqcSetPar(ww, kset, idtthrc6, tthrs6(4) )
      call sqcSetPar(ww, kset, idtthrb6, tthrs6(5) )
      call sqcSetPar(ww, kset, idtthrt6, tthrs6(6) )
      call sqcSetPar(ww, kset, idrthrc6, rthrs6(4) )
      call sqcSetPar(ww, kset, idrthrb6, rthrs6(5) )
      call sqcSetPar(ww, kset, idrthrt6, rthrs6(6) )
      call sqcSetPar(ww, kset, idaar6,   aar6      )
      call sqcSetPar(ww, kset, idbbr6,   bbr6      )
      call sqcSetPar(ww, kset, idymaxc2, ymaxc2    )
      call sqcSetPar(ww, kset, idtminc2, tminc2    )
      call sqcSetPar(ww, kset, idtmaxc2, tmaxc2    )
      call sqcSetPar(ww, kset, idaslim6, aslim6    )
      call sqcSetPar(ww, kset, idipver6, dipver6   )

      return
      end

C     ===================================
      subroutine sqcSetPar(ww,kset,i,val)
C     ===================================

C--   Set value of parameter (i) of pdf set (kset) in ww
C--
C--   ww   (in) : workspace
C--   kset (in) : table set identifier in ww
C--   i    (in) : parameter index [1,mpar0]
C--   val  (in) : parameter value
C--
C--   NB: it is not checked if kset exists or if sufficient param space

      implicit double precision (a-h,o-z)

      dimension ww(*)

      ia       = iqcFirstWordOfParams(ww,kset)-1
      ww(ia+i) = val

      return
      end

C     ===================================
      subroutine sqcGetPar(ww,kset,i,val)
C     ===================================

C--   Get value of parameter (i) of pdf set (kset) in ww
C--
C--   ww   (in) : workspace
C--   kset (in) : table set identifier in ww
C--   i    (in) : parameter index [1,mpar0]
C--   val (out) : parameter value
C--
C--   NB: it is not checked if kset exists or if sufficient param space

      implicit double precision (a-h,o-z)

      dimension ww(*)

      ia   = iqcFirstWordOfParams(ww,kset)-1
      val  = ww(ia+i)

      return
      end

C     =======================================
      subroutine sqcCpyPar(w1,kset1,w2,kset2)
C     =======================================

C--   Copy the parameter list of kset1 in w1 to kset2 in w2
C--
C--   w1,2    (in) : workspaces
C--   kset1,2 (in) : kset identifiers

      implicit double precision (a-h,o-z)

      include 'qcdnum.inc'

      dimension w1(*), w2(*)

      logical lqcIsetExists

      if(.not.lqcIsetExists(w1,kset1)) then
        stop 'sqcCpyPar: kset1 does not exist'
      endif
      if(.not.lqcIsetExists(w2,kset2)) then
        stop 'sqcCpyPar: kset2 does not exist'
      endif

      if(iqcGetNumberOfParams(w1,kset1).lt.mpar0) then
        stop 'sqcCpyPar: not enough parameter space in kset1'
      endif
      if(iqcGetNumberOfParams(w2,kset2).lt.mpar0) then
        stop 'sqcCpyPar: not enough parameter space in kset2'
      endif

      ia1 = iqcFirstWordOfParams(w1,kset1)-1
      ia2 = iqcFirstWordOfParams(w2,kset2)-1

      do i = 1,mpar0
        ia1     = ia1+1
        ia2     = ia2+1
        w2(ia2) = w1(ia1)
      enddo

      return
      end

C     =============================
      subroutine sqcClrPar(ww,kset)
C     =============================

C--   Set all parameters of kset to zero

      implicit double precision (a-h,o-z)

      include 'qcdnum.inc'

      dimension ww(*)

      logical lqcIsetExists

      if(.not.lqcIsetExists(ww,kset)) then
        stop 'sqcClrPar: kset does not exist'
      endif

      mpar = iqcGetNumberOfParams(ww,kset)
      ia   = iqcFirstWordOfParams(ww,kset)-1

      do i = 1,mpar
        ww(ia+i) = 0.D0
      enddo

      return
      end

C     =======================================
      logical function lqcParsEqPar6(ww,kset)
C     =======================================

C--   True if all parameters in kset are equal to those in /qpars6/

      implicit double precision (a-h,o-z)

      include 'qcdnum.inc'
      include 'qgrid2.inc'
      include 'qpars6.inc'

      dimension ww(*)

      logical lqcIsetExists,lqcParEqVal

      if(.not.lqcIsetExists(ww,kset)) then
        stop 'lqcParsEqPar6: kset does not exist'
      endif
      if(iqcGetNumberOfParams(ww,kset).lt.mpar0) then
        np = iqcGetNumberOfParams(ww,kset)
        write(6,*) 'kset, npar, mpar = ',kset,np,mpar0
        stop 'lqcParsEqPar6: not enough parameter space'
      endif

      diord6 = dble(iord6)
      if(Lmfns6) then
        dnfix6 = -dble(nfix6)
      else
        dnfix6 =  dble(nfix6)
      endif

      lqcParsEqPar6 = lqcParEqVal(ww, kset, idiord6,  diord6    )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idalfq06, alfq06    )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idq0alf6, q0alf6    )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idnfix6,  dnfix6    )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idqthrc6, qthrs6(4) )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idqthrb6, qthrs6(5) )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idqthrt6, qthrs6(6) )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idtthrc6, tthrs6(4) )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idtthrb6, tthrs6(5) )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idtthrt6, tthrs6(6) )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idrthrc6, rthrs6(4) )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idrthrb6, rthrs6(5) )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idrthrt6, rthrs6(6) )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idaar6,   aar6      )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idbbr6,   bbr6      )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idymaxc2, ymaxc2    )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idtminc2, tminc2    )
      if(.not.lqcParsEqPar6) return
      lqcParsEqPar6 = lqcParEqVal(ww, kset, idtmaxc2, tmaxc2    )

      return
      end

C     ===========================================
      logical function lqcParEqVal(ww,kset,i,val)
C     ===========================================

C--   True if parameter (i) in kset is equal to val
C--
C--   ww   (in) : workspace
C--   kset (in) : table set identifier in ww
C--   i    (in) : parameter index [1,mpar0]
C--   val (out) : value to be checked
C--
C--   NB: it is not checked if kset exists or if sufficient param space

      implicit double precision (a-h,o-z)

      dimension ww(*)

      ia   = iqcFirstWordOfParams(ww,kset)-1
      par  = ww(ia+i)
      if(par.eq.val) then
        lqcParEqVal = .true.
      else
        lqcParEqVal = .false.
      endif

      return
      end







